Attribute VB_Name = "MBFRoutines"
Option Explicit

' VB Wrapper routines for MicroDexterity's 
' FREEWARE mbfiee32.DLL for MBF <-> IEEE Conversion
'
' Contributed by Tim Jones, Aquarian Technologies
'
' MicroDexterity sez:
' 
' Please note that the included VB functions are deprecated 
' for any use that might cross national language boundaries.  
' Arbitrary byte data encoded as Unicode strings will not
' survive intact when moving the data from (for example) 
' a Chinese Windows environment to a Western European one.
'
' The first two Declares must be private to this module 
' because they redefine the parameters of the Stamina 
' functions to "As Byte" to avoid strong typing.
'
Private Declare Sub DxToIEEEd Lib "mbfiee32" (ByRef X As Byte)
Private Declare Sub DxToIEEEs Lib "mbfiee32" (ByRef X As Byte)
'
Private Declare Sub DxToMBFs Lib "mbfiee32" (ByRef X As Single)
Private Declare Sub DxToMBFd Lib "mbfiee32" (ByRef X As Double)

Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" _
   (ToVar As Any, FromVar As Any, ByVal cbLen As Long)

Function CVDMBF(FilStr As String) As Double

  Dim bTmp() As Byte
  Dim dTmp As Double

  bTmp = StrConv(FilStr, vbFromUnicode)
  DxToIEEEd bTmp(0)
  CopyMem dTmp, bTmp(0), 8

  CVDMBF = dTmp

End Function 'CVDMBF

Function MKDMBF(dVar As Double) As String

  Dim bTmp(0 To 7) As Byte
  Dim dTmp As Double

  dTmp = dVar
  DxToMBFd dTmp
  CopyMem bTmp(0), dTmp, 8

  MKDMBF = StrConv(bTmp, vbUnicode)

End Function 'MKDMBF

Function CVSMBF(FilStr As String) As Single

  Dim bTmp() As Byte
  Dim sngTmp As Single

  bTmp = StrConv(FilStr, vbFromUnicode)
  DxToIEEEs bTmp(0)
  CopyMem sngTmp, bTmp(0), 4

  CVSMBF = sngTmp

End Function 'CVSMBF

Function MKSMBF(sngVar As Single) As String

  Dim bTmp(0 To 3) As Byte
  Dim sngTmp As Single

  sngTmp = sngVar
  DxToMBFs sngTmp
  CopyMem bTmp(0), sngTmp, 4

  MKSMBF = StrConv(bTmp, vbUnicode)

End Function 'MKSMBF
